// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
// -*-C++-*-
//
// File:      AsciiFormatter.h
// Author:    Jorgo Bakker (jbakker@rssd.esa.int)
// Generated: Mon Jan 27 14:09:35 CET 2003
// Usage:     -
// Info:      -


#ifndef AsciiFormatter_h
#define AsciiFormatter_h

#include "MessageFormatter.h"

class AsciiFormatter : public /* implementation of */ MessageFormatter
{
public:
  AsciiFormatter();
  virtual ~AsciiFormatter();

  void setDecodeListener(MessageHandler*) {/*nothing!*/}

  virtual void message(const std::string& name,
		       const std::string& text);

  virtual void warning(const std::string& name,
		       const std::string& code, 
		       const std::string& text);

  virtual void error(const std::string& name,
		     const std::string& code, 
		     const std::string& text);

  virtual void fatal(const std::string& name,
		     const std::string& code, 
		     const std::string& text);

  virtual void decode() { /*nothing!*/}

private:
  AsciiFormatter(const AsciiFormatter&);             // disabled!
  AsciiFormatter& operator=(const AsciiFormatter&); // disabled!
};

#endif
