// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
// -*-C++-*-
//
// File:      MessageHandler.h
// Author:    Jorgo Bakker (jbakker@rssd.esa.int)
// Generated: Mon Jan 27 16:39:34 CET 2003
// Usage:     -
// Info:      -

#ifndef MessageHandler_h
#define MessageHandler_h

#include <string>

class MessageHandler
{
public:
  MessageHandler(){}
  virtual ~MessageHandler() {}

  virtual void message(const std::string& name,
		       const std::string& text) =0;

  virtual void warning(const std::string& name,
		       const std::string& code, 
		       const std::string& text) =0;

  virtual void error(const std::string& name,
		     const std::string& code, 
		     const std::string& text) =0;

  virtual void fatal(const std::string& name,
		     const std::string& code, 
		     const std::string& text) =0;

private:
  MessageHandler(const MessageHandler&);            // disabled
  MessageHandler& operator=(const MessageHandler&); // disabled
};



#endif
