// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
// -*-c++-*-
// (c) 1997 European Space Agency - written by Marco Beijersbergen
//

#ifndef Msg_h
#define Msg_h

#include <string>
#include <iostream>

typedef std::string Code;

struct Msg {
  class Layer
  {
  public:
    Layer() : _data(0) {}
    Layer(int i) : _data(i) {}
    operator int() {return _data;}
    friend std::ostream& operator<<(std::ostream&,const Layer&);
    friend std::istream& operator>>(std::istream&,Layer&);
  private:
    int _data;
  };
  static const  Layer UI, Meta, App, AppLib, Lib, Core, Kernel;

  class Verbosity
  {
  public:
    Verbosity() : _data(0) {}
    Verbosity(int i) : _data(i) {}
    operator int() const {return _data;}
    friend std::ostream& operator<<(std::ostream&,const Verbosity&);
    friend std::istream& operator>>(std::istream&,Verbosity&);
  private:
    int _data;
  };
  static const Verbosity  Silent, Sparse, Verbose, Noisy, Always;

  Layer layer;
  Verbosity level;

};

inline std::ostream& operator<<(std::ostream& os,const Msg::Layer& l)
{
  return (os << l._data);
}
inline std::istream& operator>>(std::istream& is,Msg::Layer& l)
{
  return (is >> l._data);
}
inline std::ostream& operator<<(std::ostream& os,const Msg::Verbosity& v)
{
  return (os << v._data);
}
inline std::istream& operator>>(std::istream& is,Msg::Verbosity& v)
{
  return (is >> v._data);
}
#endif
