// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#include<ExceptionErrorHandler.h>
#include<errstr.h>

SetExceptionErrorHandler::SetExceptionErrorHandler()
    : exception_handler_(ExceptionErrorHandler())
{
    saved_handler_ = errHandler.handler(&exception_handler_);
    // Passes the name of the client and the verbosity on to the new handler.
    errHandler.name(saved_handler_->name());
    errHandler.verbosity(saved_handler_->verbosity());
    
}

SetExceptionErrorHandler::~SetExceptionErrorHandler()
{
    errHandler.handler(saved_handler_);
}
