// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
/*
    error.h

    C interface to the error handling.

    (c) 1999 European Space Agency - written by Marco Beijersbergen
*/

#ifndef error_h
#define error_h

#ifdef __cplusplus
extern "C" {
#endif

typedef enum { UIMsg=1, MetaMsg, AppMsg, AppLibMsg, LibMsg, CoreMsg, KernelMsg } MsgLayer;

typedef enum { SilentMsg, SparseMsg, VerboseMsg, NoisyMsg } MsgLevel;

void sas_message(MsgLayer layer, MsgLevel level, const char* fmt, ...);

void sas_warning(const char* code, const char* fmt, ...);

void sas_error(const char* code, const char* fmt, ...);

void sas_fatal(const char* code, const char* fmt, ...);

#ifdef __cplusplus
}
#endif

#endif
