// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
// -*-C++-*-
//
// File:      freezestream.h
// Author:    jbakker
// Generated: Thu Jun 22 15:58:43 MET DST 2000

#ifndef freezestream_h
#define freezestream_h

#include <strstream>

/*
  The GNU sstream (at least in egcs-1.1.1) contains a bug. When using ss.str(),
  it implicitly should freeze(0) the stream, such that proper cleanupis done.

  However, due to the bug, memory is leaking.
 */
inline std::string freezestream(ostrstream& ss)
{
  char *chCopy = ss.str();
  ss.freeze(1);
  std::string result(chCopy);
  delete chCopy;

  return result;
}

inline std::string freezestream(strstream& ss)
{
  char *chCopy = ss.str();
  ss.freeze(1);
  std::string result(chCopy);
  delete chCopy;

  return result;
}


#endif
