// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#include "../src/SuppressHandler.h"
#include <iostream>

void show(SuppressHandler& s,const Code& c)
{
  if (s.suppress(c)) return;
  std::cout << " # Warning(" << c  << ")" << std::endl;
}

void handle(SuppressHandler& s)
{

  for(int n=0;n<4;n++) {
    show(s,"Foo");
    show(s,"Bar");
    show(s,"Nope");
  }
}

int main(int argc,char** argv)
{
  std::cout << "--- run ---" << std::endl;
  SuppressHandler s;

  // Parse remaining parameters.
  int i = 0;
  while (++i < argc) {
    s.ignore(argv[i]);
  }

  // process
  handle(s);

  // 
  std::cout << " statistics: " << s.statistics() << std::endl;
  std::cout << " options:" << s.options() << std::endl;
  return 0;

}
