// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
#include <errstr.h>
#include <cstdlib>

void a()
{
    errstr << "The global verbosity is " << errHandler.verbosity() << Sas::message(Msg::App,Msg::Silent);
    errstr << "The application verbosity is " << errHandler.verbosity(Msg::App) << Sas::message(Msg::App,Msg::Silent);
    errstr << "This should be shown" << Sas::message(Msg::App,Msg::Sparse);
    errstr << "This should not be shown" << Sas::message(Msg::App,Msg::Verbose);
    errstr << 3.1415927 << " " << std::endl;
    errstr << "looks suspicious";
    errstr << Sas::warning("someWarning");
}

void b()
{
    errstr << 2.7182818 << " " << "looks better" << Sas::error("someError");
}

void c()
{
    errstr << 1.532344 << " " << " is really fatal" << Sas::fatal("someFatalError");
}

void d()
{
    Sas::error("someError","some error");
}

int main(int argc, char *argv[])
{
  errHandler.name(argv[0]);
  int level=4;
  if (argc == 2) level=atoi(argv[1]);
  errHandler.verbosity(level);

  errstr << "Verbosity is set to " << errHandler.verbosity() 
	 << Sas::message(Msg::App,Msg::Always);

  a();
#ifdef EXCEPTIONS
  try { b(); } catch (...) { std::cerr << "an exception was raised" << std::endl; }
  try { c(); } catch (...) { std::cerr << "an exception was raised" << std::endl; }
  try { d(); } catch (...) { std::cerr << "an exception was raised" << std::endl; }
#else
  b();
  c();
  d();
#endif
}

